unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus, ComCtrls, Spin;

type
  PAkce = ^TAkce;
  TAkce = record
    plyn: boolean;
    hodnota: real;
    dalsi: PAkce;
    n: integer;
  end;

  TForm1 = class(TForm)
    Panel1: TPanel;
    Start: TButton;
    Stop: TButton;
    Panel2: TPanel;
    EditVyska: TEdit;
    EditRychlost: TEdit;
    EditZrychleni: TEdit;
    EditObjem: TEdit;
    EditTeplota: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    SpinEditInterval: TSpinEdit;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Odhod: TButton;
    Vypust: TButton;
    SpinEditKolikrat: TSpinEdit;
    Label13: TLabel;
    Timer: TTimer;
    Label14: TLabel;
    Dalsi: TButton;
    Novy: TButton;
    CheckBox1: TCheckBox;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    EditZatez: TEdit;
    Label23: TLabel;
    TrackBarObjem: TTrackBar;
    TrackBarHmotnost: TTrackBar;
    EditOdhHmotnost: TEdit;
    EditVypObjem: TEdit;
    Label9: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    procedure Inicializuj(Sender: TObject);
    procedure Konec1Click(Sender: TObject);
    procedure Simulace_letu(Sender: TObject);
    procedure StartClick(Sender: TObject);
    procedure Dilky;
    procedure Pocitej(kolikrat: integer);
    procedure Prekresli;
    procedure Osy;
    function f(hh: real; vv: real): real;
    procedure StopClick(Sender: TObject);
    procedure NovyClick(Sender: TObject);
    procedure DalsiClick(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure OdhodClick(Sender: TObject);
    procedure VypustClick(Sender: TObject);
    procedure SpinEditIntervalExit(Sender: TObject);
    procedure SpinEditKolikratExit(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TrackBarObjemChange(Sender: TObject);
    procedure TrackBarHmotnostChange(Sender: TObject);
  private
    Zrychleni: real;
    Pom: integer;

    p0, V0, VM, m0, odhod_pomer, vypust_pomer: real;

    dt_int: integer;

    h_max, h_maxM, v_max, v_min, a_max, tep_stred, tep_max: integer;
    {maximln hodnoty rychlosti a zrychlen v grafu}

    barva_osy, barva_pozadi, barva_vyska, barva_rychlost, barva_zrychleni, barva_teplota: integer;

    nula_rychlost, mez_teplota, dilek_t, dilek_h, dilek_tep, dilek_v, dilek_a, dilek_osy: real;

    dt, m : real;

    x_min, x_max, y_min, y_max, y_rozsah, x_nula, y_nula, v_nula, tep_nula : integer;

    h1, h2, v1, v2, a1, a2, ap, tp, t, g, C, Rm, Mm, V, teps, tep, S, p : real;

    kolikrat, n: integer;

    prekresluje, vsechny, prvni, max_nalezeno_h, max_nalezeno_h3, max_nalezeno_v, konec: boolean;

    Akce, aktAkce: PAkce;
  public
  end;

var
  Form1: TForm1;

implementation

uses Unit2;

{$R *.DFM}

const k1=8.2099e-7;
      h_mist=7;
      v_mist=8;
      a_mist=9;
      obj_mist=11;
      obj_mist2=8;
      tep_mist=8;
      zatez_mist=11;
      zatez_mist2=8;
      y_posun=30;

procedure TForm1.Inicializuj(Sender: TObject);
begin
  Stop.Enabled:=false;
  Start.Enabled:=false;
  Dalsi.Enabled:=false;
  Odhod.Enabled:=false;
  Vypust.Enabled:=false;
  Timer.Enabled:=false;

  prvni:=true;
  konec:=false;

  Zrychleni:=0;
  Pom:=0;
  Panel1.Width:=ClientWidth;
  Panel2.Width:=ClientWidth;
  Panel2.Top:=ClientHeight-Panel2.Height;

  y_min:=Panel1.Height+1;
  y_max:=ClientHeight-Panel2.Height-1;
  x_min:=1;
  x_max:=ClientWidth-1;

  tep_nula:=y_min+30;
  y_rozsah:=y_max-y_posun-tep_nula;

  barva_osy:=clWhite;
  barva_pozadi:=clBlack;
  barva_vyska:=clWhite;
  barva_rychlost:=clYellow;
  barva_zrychleni:=$0000ff00;
  barva_teplota:=clRed;

  h_max:=40;
  h_maxM:=40000;
  v_max:=40;
  v_min:=-20;
  a_max:=10;
  tep_max:=20;
  tep_stred:=-60;
  nula_rychlost:=1-v_max/(v_max-v_min);
  mez_teplota:=0.82;

  V0:=20000;
  VM:=100000;
  m0:=1500;
  p0:=100000;
  m:=m0+V0*p0*k1;

  dt_int:=100;
  dt:=dt_int/1000;
  kolikrat:=50;
  vsechny:=false;

  SpinEditInterval.Value:=dt_int;
  SpinEditKolikrat.Value:=kolikrat;
  CheckBox1.Checked:=false;

  Dilky;

  New(Akce);
  Akce^.dalsi:=nil;
  aktAkce:=Akce;

  odhod_pomer:=TrackBarHmotnost.Position/TrackBarHmotnost.Max;
  vypust_pomer:=TrackBarObjem.Position/TrackBarObjem.Max;
end;

procedure TForm1.Dilky;
begin
  dilek_h:=y_rozsah/h_maxM;
  dilek_v:=y_rozsah/(v_max-v_min);
  dilek_tep:=y_rozsah/((tep_max-tep_stred)/mez_teplota);
  dilek_a:=y_rozsah/a_max;
end;

procedure TForm1.Konec1Click(Sender: TObject);
begin
  Form1.Close;
end;

procedure TForm1.Osy;
const x_posun=55;
var i, x_cisla: integer;
    pomstr: string;
begin
  x_nula:=x_min+x_posun;
  y_nula:=y_max-y_posun;
  v_nula:=round(y_nula-nula_rychlost*y_rozsah);

  Canvas.Brush.Color:=barva_pozadi;
  Canvas.FillRect(Rect(x_min,y_min,x_max,y_max));
  Canvas.Pen.Color:=barva_osy;
  Canvas.MoveTo(x_min+x_posun-5,tep_nula);
  Canvas.LineTo(x_min+x_posun+5,tep_nula);
  Canvas.MoveTo(x_min+x_posun-5,tep_nula+round(y_rozsah*(mez_teplota)));
  Canvas.LineTo(x_min+x_posun+5,tep_nula+round(y_rozsah*(mez_teplota)));
  Canvas.MoveTo(x_min+x_posun,y_min+5);
  Canvas.LineTo(x_min+x_posun,y_max-y_posun);
  Canvas.LineTo(x_max-5,y_max-y_posun);
  Canvas.Pen.Color:=barva_rychlost;
  Canvas.MoveTo(x_min+x_posun-5,v_nula);
  Canvas.LineTo(x_min+x_posun+3,v_nula);
  Canvas.Pen.Style:=psDot;
  Canvas.LineTo(x_max-5,v_nula);
  Canvas.Pen.Style:=psSolid;

  Canvas.Font.Color:=barva_osy;
  Canvas.Font.Size:=12;
  Canvas.TextOut(x_max-50,y_max-y_posun+5,'t / s');

  Canvas.Pen.Color:=barva_osy;
  Canvas.Font.Size:=10;
  dilek_osy:=(x_max-x_min-35)/12;
  for i:=1 to 10 do begin
    pom:=x_min+x_posun+round(i*dilek_osy);
    Canvas.MoveTo(pom,y_max-y_posun-5);
    Canvas.LineTo(pom,y_max-y_posun+5);
    str(i*500,pomstr);
    Canvas.TextOut(pom-10,y_max-y_posun+7,pomstr);
  end;

  dilek_t:=dilek_osy/500;

  x_cisla:=x_min+x_posun-50;

  str(h_max:2,pomstr);
  Canvas.TextOut(x_cisla,y_min+15,pomstr+' km');

  Canvas.Font.Color:=barva_rychlost;
  str(v_max:2,pomstr);
  Canvas.TextOut(x_cisla,y_min+40,pomstr+' m/s');
  Canvas.TextOut(x_cisla+10,v_nula,'0 m/s');
  str(v_min:2,pomstr);
  Canvas.TextOut(x_cisla,y_max-y_posun-15,pomstr+' m/s');

  Canvas.Font.Color:=barva_zrychleni;
  str(a_max:2,pomstr);
  Canvas.TextOut(x_cisla,y_min+65,pomstr+' m/s');
  Canvas.Font.Size:=8;
  Canvas.TextOut(x_cisla+41,y_min+59,'2');
  Canvas.Font.Size:=10;

  Canvas.Font.Color:=barva_teplota;
  str(tep_max:2,pomstr);
  Canvas.TextOut(x_cisla,y_min+90,pomstr+' C');
  str(tep_stred:2,pomstr);
  Canvas.TextOut(x_cisla+9,tep_nula+round(y_rozsah*(mez_teplota)),pomstr+' C');

end;

function TForm1.f(hh: real; vv: real): real;
var k:integer;
    ro: real;
begin
  k:=1;
  if vv<0 then k:=-1;
  p:=p0*exp(-hh/7200);
  ro:=p*Mm/Rm/tep/1000;
  f:= -g+ro/m*(V*g-C*S*vv*vv/2*k);
end;

procedure TForm1.Pocitej;
var i: integer;
    x_sour1, x_sour2: integer;
    pomstr: string;
begin
  for i:=1 to kolikrat do begin
    if (t<=5300) and (h1>=0) then begin
      if h1<12000 then tep:=293-h1/12000*80
      else
        if h1>23000 then tep:= 213.16-tep_stred*(h1-23000)/20000
        else
          tep:=213;
      a1:=f(h1,v1);
      V:=V0*p0/p;
      if V>VM then V:=VM;
      S:=exp(ln(sqr(V)*5.585)/3);  // Pi/075/075=5.585
      a2:=f(h1+dt*v1,v1+dt*a1);
      v2:=v1+dt/2*(a1+a2);
      h2:=h1+dt/2*(v1+v2);
      t:=t+dt;
      if not prekresluje then inc(n);

      x_sour1:=x_nula+round(tp*dilek_t);
      x_sour2:=x_nula+round(t*dilek_t);

      //zanese hodnotu vysky do grafu
      Canvas.Pen.Color:=barva_vyska;
      Canvas.MoveTo(x_sour1,round(y_nula-h1*dilek_h));
      Canvas.LineTo(x_sour2,round(y_nula-h2*dilek_h));

      //zanese hodnotu rychlosti do grafu
      Canvas.Pen.Color:=barva_rychlost;
      if (v2<v_min) or (v2>v_max) or (h2>h_maxM) then begin
        if (v2<v_min) or (v2>v_max) then begin
          repeat
            v_max:=v_max*2;
            v_min:=v_min*2;
          until (v2>v_min) and (v2<v_max);
          dilek_v:=y_rozsah/(v_max-v_min);
        end;
        if (h2>h_maxM) then begin
          repeat
            h_max:=h_max*2;
            h_maxM:=h_maxM*2;
          until (h2<h_maxM);
          dilek_h:=y_rozsah/h_maxM;
        end;
        prekresli;
      end;
      Canvas.MoveTo(x_sour1,round(v_nula-v1*dilek_v));
      Canvas.LineTo(x_sour2,round(v_nula-v2*dilek_v));

      //zanese hodnotu zrychleni do grafu
      Canvas.Pen.Color:=barva_zrychleni;
      Canvas.MoveTo(x_sour1,round(y_nula-ap*dilek_a));
      Canvas.LineTo(x_sour2,round(y_nula-a2*dilek_a));

      //zanese hodnotu teploty do grafu
      Canvas.Pen.Color:=barva_teplota;
      Canvas.MoveTo(x_sour1,round(tep_nula+(293-teps)*dilek_tep));
      Canvas.LineTo(x_sour2,round(tep_nula+(293-tep)*dilek_tep));

      if (h1>h2) and (h1>30000) and (not max_nalezeno_h3) then begin
        Str(h1/1000:5:2,pomstr);
        max_nalezeno_h3:=true;
        max_nalezeno_h:=true;
        Canvas.Font.Color:=barva_vyska;
        Canvas.TextOut(x_sour2,round(y_nula-h2*dilek_h)-20,pomstr+' km');
      end;
      if (h1>h2) and (not max_nalezeno_h) then begin
        Str(h1/1000:5:2,pomstr);
        max_nalezeno_h:=true;
        Canvas.Font.Color:=barva_vyska;
        Canvas.TextOut(x_sour2,round(y_nula-h2*dilek_h)-20,pomstr+' km');
      end;
      if (v1>=v2) and (not max_nalezeno_v) and (t>50) then begin
        Str(v1:5:2,pomstr);
        max_nalezeno_v:=true;
        Canvas.Font.Color:=barva_rychlost;
        Canvas.TextOut(x_sour2,round(v_nula-v2*dilek_v)-20,pomstr+' m/s');
      end;

      h1:=h2; v1:=v2; a1:=a2; ap:=a2; tp:=t; teps:=tep;
    end;
  end;
end;

procedure TForm1.Prekresli;
var pomAkce: PAkce;
    i: integer;
begin
  if not konec then begin
    V0:=Form2.Objem.Value;
    VM:=Form2.ObjemMax.Value;
    m0:=Form2.Hmotnost.Value;
    p0:=Form2.Tlak.Value;
    m:=m0+V0*p0*k1;

    teps:=293;
    h1:=0; h2:=0; v1:=0; v2:=0; a1:=0; a2:=0; ap:=0; tp:=0; t:=0;
    g:=9.81; C:=0.37; Rm:=8.3143; Mm:= 29; V:=V0;
    max_nalezeno_h:=false; max_nalezeno_h3:=false; max_nalezeno_v:=false;
    Osy;
    Start.Enabled:=true;
    Dalsi.Enabled:=true;
//    Vypust.Enabled:=true;
//    Odhod.Enabled:=true;
    prekresluje:=true;
    pomAkce:=Akce;
    i:=0;
    while pomAkce^.dalsi<>nil do begin
      pomAkce:=pomAkce^.dalsi;
      if (pomAkce^.n-i)>0 then pocitej(pomAkce^.n-i);
      if pomAkce^.plyn then begin
        V:=V-V*pomAkce^.hodnota;
        if V<1e-10 then begin
          V:=1e-10;
          Canvas.Font.Color:=$0000cdef;
          Canvas.TextOut(x_max-200,y_min+20,'Baln je zcela vyputn!');
        end;
        m:=m-(m-m0)*pomAkce^.hodnota;
        V0:=V*p/p0;
      end
      else begin
        m0:=m0-pomAkce^.hodnota;
        if m0<=0 then begin
          m0:=10;
          Canvas.Font.Color:=$0000cdef;
          Canvas.TextOut(x_max-200,y_min+45,'Hmotnost klesla na 0!');
        end;
        m:=m0+V0*p0*k1;
      end;
      i:=pomAkce^.n;
    end;
    if (n-i)>0 then pocitej(n-i);
    prekresluje:=false;

    if (t>5300) or (h1<0) then begin
      Timer.Enabled:=false;
      Start.Enabled:=false;
      Dalsi.Enabled:=false;
      Stop.Enabled:=false;
      Odhod.Enabled:=false;
      Vypust.Enabled:=false;
      Novy.Enabled:=true;
    end;
  end;
end;

procedure TForm1.Simulace_letu(Sender: TObject);
var pomstr: string;

begin
  Pocitej(kolikrat);

  Str(h2/1000:h_mist:2,pomstr);
  EditVyska.Text:=pomstr;

  Str(v2:v_mist:2,pomstr);
  EditRychlost.Text:=pomstr;

  Str(a2:a_mist:2,pomstr);
  EditZrychleni.Text:=pomstr;

  Str(V:obj_mist:2,pomstr);
  EditObjem.Text:=pomstr;

  Str(tep-273:tep_mist:2,pomstr);
  EditTeplota.Text:=pomstr;

  Str(round(V*vypust_pomer):obj_mist2,pomstr);
  EditVypObjem.Text:=pomstr;

  if (t>5300) or (h1<0) then begin
    Timer.Enabled:=false;
    Start.Enabled:=false;
    Dalsi.Enabled:=false;
    Stop.Enabled:=false;
    Odhod.Enabled:=false;
    Vypust.Enabled:=false;
    Novy.Enabled:=true;
  end;
end;

procedure TForm1.StartClick(Sender: TObject);
begin
  if not Vypust.Enabled then Vypust.Enabled:=true;
  if not Odhod.Enabled then Odhod.Enabled:=true;
  Start.Enabled:=false;
  Dalsi.Enabled:=false;
  Stop.Enabled:=true;
  Timer.Enabled:=true;
end;

procedure TForm1.StopClick(Sender: TObject);
begin
  Timer.Enabled:=false;
  Stop.Enabled:=false;
  Start.Enabled:=true;
  Dalsi.Enabled:=true;
end;

procedure TForm1.NovyClick(Sender: TObject);
var pomstr:string;
    pomAkce: PAkce;
begin
  if prvni then begin
    Form2.Objem.Value:=round(V0);
    Form2.ObjemMax.Value:=round(VM);
    Form2.Hmotnost.Value:=round(m0);
    Form2.Tlak.Value:=round(p0);
    prvni:=false;
  end;
  Form2.ShowModal;
  V0:=Form2.Objem.Value;
  VM:=Form2.ObjemMax.Value;
  m0:=Form2.Hmotnost.Value;
  p0:=Form2.Tlak.Value;
  m:=m0+V0*p0*k1;
  v_max:=40;
  v_min:=-20;
  dilek_v:=y_rozsah/(v_max-v_min);
  h_max:=40;
  h_maxM:=40000;
  dilek_h:=y_rozsah/h_maxM;

  EditVyska.Text:='0';
  EditRychlost.Text:='0';
  EditZrychleni.Text:='0';
  Str(V0:obj_mist:2,pomstr);
  EditObjem.Text:=pomstr;
  EditTeplota.Text:='       20';
  Str(m0:zatez_mist:0,pomstr);
  EditZatez.Text:=pomstr;

  Str(round(m0*odhod_pomer):zatez_mist2,pomstr);
  EditOdhHmotnost.Text:=pomstr;

  Str(round(V0*vypust_pomer):obj_mist2,pomstr);
  EditVypObjem.Text:=pomstr;

  teps:=293;
  h1:=0; h2:=0; v1:=0; v2:=0; a1:=0; a2:=0; ap:=0; tp:=0; t:=0; n:=0;
  g:=9.81; C:=0.37; Rm:=8.3143; Mm:= 29; V:=V0;
  max_nalezeno_h:=false; max_nalezeno_h3:=false; max_nalezeno_v:=false;
  Osy;
  Start.Enabled:=true;
  Dalsi.Enabled:=true;
  Vypust.Enabled:=false;
  Odhod.Enabled:=false;
  prekresluje:=false;

  while Akce^.dalsi<>nil do begin
    pomAkce:=Akce;
    Akce:=Akce^.dalsi;
    dispose(pomAkce);
  end;
  aktAkce:=Akce;
end;

procedure TForm1.DalsiClick(Sender: TObject);
begin
  if not Vypust.Enabled then Vypust.Enabled:=true;
  if not Odhod.Enabled then Odhod.Enabled:=true;
  Simulace_Letu(Sender);
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  vsechny:=CheckBox1.Checked;
  if vsechny then begin
    SpinEditKolikrat.Enabled:=false;
    Label13.Enabled:=false;
    Label14.Enabled:=false;
    kolikrat:=1;
  end
  else begin
    kolikrat:=SpinEditKolikrat.Value;
    SpinEditKolikrat.Enabled:=true;
    Label13.Enabled:=true;
    Label14.Enabled:=true;
  end;
end;

procedure TForm1.OdhodClick(Sender: TObject);
var pomstr:string;
    pomAkce: PAkce;
begin
  m0:=round(m0-m0*odhod_pomer);
  str(m0:zatez_mist:0,pomstr);
  EditZatez.Text:=pomstr;
  if m0<=0 then begin
    m0:=10;
    Canvas.Font.Color:=$0000cdef;
    Canvas.TextOut(x_max-200,y_min+45,'Hmotnost klesla na 0!');
  end;
  m:=m0+V0*p0*k1;

  Str(round(m0*odhod_pomer):zatez_mist2,pomstr);
  EditOdhHmotnost.Text:=pomstr;

  New(pomAkce);
  aktAkce^.dalsi:=pomAkce;
  pomAkce^.dalsi:=nil;
  pomAkce^.plyn:=false;
  pomAkce^.hodnota:=m0*odhod_pomer;
  pomAkce^.n:=n;
  aktAkce:=pomAkce;
end;

procedure TForm1.VypustClick(Sender: TObject);
var pomstr:string;
    pomAkce: PAkce;
begin
  V:=V-V*vypust_pomer;
  if V<1e-10 then begin
    V:=1e-10;
    Canvas.Font.Color:=$0000cdef;
    Canvas.TextOut(x_max-200,y_min+20,'Baln je zcela vyputn!');
  end;
  V0:=V*p/p0;

  Str(round(V*vypust_pomer):obj_mist2,pomstr);
  EditVypObjem.Text:=pomstr;

  m:=m-(m-m0)*vypust_pomer;
  str(V:obj_mist:2,pomstr);
  EditObjem.Text:=pomstr;

  New(pomAkce);
  aktAkce^.dalsi:=pomAkce;
  pomAkce^.dalsi:=nil;
  pomAkce^.plyn:=true;
  pomAkce^.hodnota:=vypust_pomer;
  pomAkce^.n:=n;
  aktAkce:=pomAkce;
end;

procedure TForm1.SpinEditIntervalExit(Sender: TObject);
begin
  dt_int:=SpinEditInterval.Value;
  dt:=dt_int/1000;
end;

procedure TForm1.SpinEditKolikratExit(Sender: TObject);
begin
  kolikrat:=SpinEditKolikrat.Value;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  Timer.Enabled:=false;
  Stop.Enabled:=false;
  Panel1.Width:=ClientWidth;
  Panel2.Width:=ClientWidth;
  y_min:=Panel1.Height+1;
  y_max:=ClientHeight-Panel2.Height-1;
  x_min:=1;
  x_max:=ClientWidth-1;
  tep_nula:=y_min+30;
  y_rozsah:=y_max-y_posun-tep_nula;
  Dilky;
  if prvni then begin
    Form2.Objem.Value:=round(V0);
    Form2.ObjemMax.Value:=round(VM);
    Form2.Hmotnost.Value:=round(m0);
    Form2.Tlak.Value:=round(p0);
  end;
  Prekresli;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  if not prvni then begin
    if Timer.Enabled=true then begin
      Timer.Enabled:=false;
      Prekresli;
      Timer.Enabled:=true;
    end
    else
      Prekresli;
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var pomAkce: PAkce;
begin
  konec:=true;
  while Akce^.dalsi<>nil do begin
    pomAkce:=Akce;
    Akce:=Akce^.dalsi;
    dispose(pomAkce);
  end;
  dispose(Akce);
end;

procedure TForm1.TrackBarObjemChange(Sender: TObject);
var pomstr:string;
begin
  vypust_pomer:=TrackBarObjem.Position/TrackBarObjem.Max;
  Str(round(V*vypust_pomer):obj_mist2,pomstr);
  EditVypObjem.Text:=pomstr;
end;

procedure TForm1.TrackBarHmotnostChange(Sender: TObject);
var pomstr:string;
begin
  odhod_pomer:=TrackBarHmotnost.Position/TrackBarHmotnost.Max;
  Str(round(m0*odhod_pomer):zatez_mist2,pomstr);
  EditOdhHmotnost.Text:=pomstr;
end;

end.


